﻿/**
 * This is a part of MCServe, which is available under the Apache license 2.0.
 * With this code, you may do whatever you want as long as that is not in conflict with this license.
 * In addition, you should have a reference to the original project to include (http://mcserve.codeplex.com).
 * 
 * Author       : Lars Krämer ( Xe77a )
 * Website      : http://www.lkraemer.de
 * Project      : MCServe (http://mcserve.codeplex.com)
 * Copyright    : Copyright (c) 2013 lkraemer.de
 * License      : http://mcserve.codeplex.com/license
 * Description  : This is a part of the core functionality of the server
 */

using MCServeCore.Universal.Functions;
using System.ComponentModel;

namespace MCServeCore.Components
{
    public class ServerWebUi : INotifyPropertyChanged
    {
        public ServerWebUi()
        {
            GameServer.Console.SendMessage("Start the WebUi", ServerConsole.OutputTarget.Console, ServerConsole.OutputTypes.Information);
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, e);
        }

        private string _Content = "";
        public string Content
        { 
            get
            {
                return _Content;
            }
            set
            {
                if (value != _Content)
                {
                    _Content = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("Content"));
                }
            }
        }

        public bool SendMessage(string message)
        {
            this.Content = this.Content + message + '\n';
            return true;
        }
    }
}
