﻿/**
 * This is a part of MCServe, which is available under the Apache license 2.0.
 * With this code, you may do whatever you want as long as that is not in conflict with this license.
 * In addition, you should have a reference to the original project to include (http://mcserve.codeplex.com).
 * 
 * Author       : Lars Krämer ( Xe77a )
 * Website      : http://www.lkraemer.de
 * Project      : MCServe (http://mcserve.codeplex.com)
 * Copyright    : Copyright (c) 2013 lkraemer.de
 * License      : http://mcserve.codeplex.com/license
 * Description  : This part contains general features of the project
 */

using System;
using System.Collections.Generic;

namespace MCServeLib.Objects
{
    public class Command
    {
        private String _Cmd = "";
        private Dictionary<String, Object> _Arguments = new Dictionary<String, Object>();

        public Command()
        {
            Cmd = "";
            Arguments = new Dictionary<String, Object>();
        }
        public Command(String cmd)
        {
            Cmd = cmd;
            Arguments = new Dictionary<String, Object>();
        }
        public Command(String cmd, Dictionary<String, Object> args)
        {
            Cmd = cmd;
            Arguments = args;
        }

        public String Cmd
        {
            get
            {
                return _Cmd;
            }
            set
            {
                _Cmd = value;
            }
        }
        public Dictionary<String, Object> Arguments
        {
            get
            {
                return _Arguments;
            }
            set
            {
                _Arguments = value;
            }
        }

        public void AddArgument(String title, Object value)
        {
            Arguments.Add(title, value);
        }
    }
}
