﻿/**
 * This is a part of MCServe, which is available under the Apache license 2.0.
 * With this code, you may do whatever you want as long as that is not in conflict with this license.
 * In addition, you should have a reference to the original project to include (http://mcserve.codeplex.com).
 * 
 * Author       : Lars Krämer ( Xe77a )
 * Website      : http://www.lkraemer.de
 * Project      : MCServe (http://mcserve.codeplex.com)
 * Copyright    : Copyright (c) 2013 lkraemer.de
 * License      : http://mcserve.codeplex.com/license
 * Description  : This part contains general features of the project
 */

using System;

namespace MCServeLib.Objects
{
    public class DatabaseInformation
    {
        private Boolean _Result = false;
        private String _Description = "";

        public DatabaseInformation(Boolean result)
        {
            _Result = result;
            _Description = "";
        }
        public DatabaseInformation(Boolean result, String description)
        {
            _Result = result;
            _Description = description;
        }

        public Boolean Result
        {
            /**
             * Returns true, while the server runs.
             */
            get
            {
                return _Result;
            }
            set
            {
                _Result = value;
            }
        }
        public String Description
        {
            /**
             * Returns true, while the server runs.
             */
            get
            {
                return _Description;
            }
            set
            {
                _Description = value;
            }
        }
    }
}
