﻿/**
 * This is a part of MCServe, which is available under the Apache license 2.0.
 * With this code, you may do whatever you want as long as that is not in conflict with this license.
 * In addition, you should have a reference to the original project to include (http://mcserve.codeplex.com).
 * 
 * Author       : Lars Krämer ( Xe77a )
 * Website      : http://www.lkraemer.de
 * Project      : MCServe (http://mcserve.codeplex.com)
 * Copyright    : Copyright (c) 2013 lkraemer.de
 * License      : http://mcserve.codeplex.com/license
 * Description  : This part contains general features of the project
 */

using System;
using System.Data.SqlServerCe;

namespace MCServeLib.Objects
{
    public class DatabaseResult
    {
        private Boolean _Result = false;
        private SqlCeDataReader _DBResults = null;

        public DatabaseResult()
        {
            _Result = false;
            _DBResults = null;
        }
        public DatabaseResult(Boolean result)
        {
            _Result = result;
            _DBResults = null;
        }
        public DatabaseResult(Boolean result, SqlCeDataReader dbresults)
        {
            _Result = result;
            _DBResults = dbresults;
        }

        public Boolean Result
        {
            /**
             * Returns true, while the server runs.
             */
            get
            {
                return _Result;
            }
            set
            {
                _Result = value;
            }
        }
        public SqlCeDataReader DBResults
        {
            /**
             * Returns true, while the server runs.
             */
            get
            {
                return _DBResults;
            }
            set
            {
                _DBResults = value;
            }
        }
    }
}
