﻿/**
 * This is a part of MCServe, which is available under the Apache license 2.0.
 * With this code, you may do whatever you want as long as that is not in conflict with this license.
 * In addition, you should have a reference to the original project to include (http://mcserve.codeplex.com).
 * 
 * Author       : Lars Krämer ( Xe77a )
 * Website      : http://www.lkraemer.de
 * Project      : MCServe (http://mcserve.codeplex.com)
 * Copyright    : Copyright (c) 2013 lkraemer.de
 * License      : http://mcserve.codeplex.com/license
 * Description  : This part contains general features of the project
 */

namespace MCServeCore.Types
{
    public enum PropertieKey
    {
        GeneratorSettings,                  /* String   |    */
        EnableCommandBlock,                 /* Boolean  |    */
        AllowNether,                        /* Boolean  |    */
        LevelName,                          /* String   |    */
        AllowFlight,                        /* Boolean  |   Allows the flight-function                   */
        ServerPort,                         /* Int32    |   The current server-port                      */
        LevelType,                          /* String   |    */
        LevelSeed,                          /* String   |   The seed for the default-world               */
        ServerIp,                           /* String   |   The current server-IP                        */
        MaxBuildHeight,                     /* Int32    |   Default is 256                               */
        SpawnNpcs,                          /* Boolean  |   Spawn NPCs like the villager                 */
        WhiteList,                          /* Boolean  |   Allows access only to registered players     */
        SpawnAnimals,                       /* Boolean  |   Spawn all animals                            */
        Hardcore,                           /* Boolean  |    */
        TexturePack,                        /* String   |    */
        OnlineMode,                         /* Boolean  |    */
        Pvp,                                /* Boolean  |   Activates Player vs Player                   */
        Difficulty,                         /* Int32    |    */
        Gamemode,                           /* String   |   Creative, Survival, etc.                     */
        MaxPlayers,                         /* Int32    |    */
        SpawnMonsters,                      /* Boolean  |   Spawn Zombies, Endermans, Creepers, etc.     */
        GenerateStructures,                 /* Boolean  |    */
        ViewDistance,                       /* Int32    |    */
        MotD,                               /* String   |   Short Server description                     */
        SpawnProtection,                    /* Int32    |    */
        SnooperEnabled,                     /* Boolean  |    */

        EnableRcon,                         /* Boolean  |   Enables the Remote API                       */
        EnableQuery,                        /* Boolean  |   Enables the Query API                        */
        EnableWebUi,                        /* Boolean  |   Enables the Webinterface                     */
    }
}
